#! /usr/bin/env ruby

# merge.rb: Written by Tadayoshi Funaba 1999-2001
# $Id: merge.rb,v 1.6 2001-03-20 13:40:59+09 tadf Exp $

require 'smf'
require 'smf/divert'
include  SMF

def usage
  $stderr.puts 'usage: merge ifile [ofile]'
  exit 1
end

usage unless $*.size >= 1 and $*.size <= 2
ifile = $*.shift
ofile = $*.shift
ofile ||= File.basename(ifile, '.mid') + '-merge.mid'

sq = Sequence.decodefile(ifile)
nsq = Sequence.new(0, sq.division)
sq.each do |tr|
  tr.divert(nsq) do |ev|
    case ev
    when EndOfTrack;  nil
    else;      0
    end
  end
end
nsq.encodefile(ofile)
